(function() {
  var AsyncInvoker, Promise, _, eval_,
    bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    slice = [].slice;

  Promise = require("bluebird");

  eval_ = require("eval");

  _ = require("lodash");

  module.exports = AsyncInvoker = (function() {
    function AsyncInvoker(code, options, globals) {
      this.options = options != null ? options : {};
      if (globals == null) {
        globals = {};
      }
      this._assertIsFunction = bind(this._assertIsFunction, this);
      this._doSomething = bind(this._doSomething, this);
      this.invoke = bind(this.invoke, this);
      _.defaults(this.options, {
        logErrors: true
      });
      code = "module.exports = " + code;
      this._invoke = this._doSomething(((function(_this) {
        return function() {
          return eval_(code, globals);
        };
      })(this)));
      this._assertIsFunction(this._invoke);
    }

    AsyncInvoker.prototype.invoke = function() {
      var args, invoke, tryLog;
      args = 1 <= arguments.length ? slice.call(arguments, 0) : [];
      invoke = (function(_this) {
        return function(functionArgs) {
          return _this._doSomething((function() {
            return _this._invoke.apply(null, functionArgs);
          }));
        };
      })(this);
      tryLog = (function(_this) {
        return function(e) {
          if (_this.options.logErrors) {
            return console.log(e);
          }
        };
      })(this);
      return new Promise((function(_this) {
        return function(resolve, reject) {
          var e, error, output;
          try {
            output = invoke(args.concat(resolve));
            if (!_.isUndefined(output)) {
              return resolve(output);
            }
          } catch (error) {
            e = error;
            tryLog(e);
            return reject(e);
          }
        };
      })(this));
    };

    AsyncInvoker.prototype._doSomething = function(doSomething) {
      return doSomething();
    };

    AsyncInvoker.prototype._assertIsFunction = function(func) {
      if (!_.isFunction(func)) {
        throw new Error("The function is not a function");
      }
    };

    return AsyncInvoker;

  })();

}).call(this);
